/******************************************************
(c) 2002 - 2003 by Daniel Vollmer <maven@maven.de>.
Licensed under the GNU Public License V2.
*******************************************************/

float fTime;

struct VS_input
{
	float4 vXFloats			: TEXCOORD0;
	float4 vYFloats			: TEXCOORD1;
};

struct VS_output
{
	float4 vPosition	: POSITION;
	float4 vColor		: COLOR0;
};

static const float PI = 3.14159265358979;

VS_output vs_draw_blobs(const VS_input v)
{ // puts particles on sinusodial paths (motion based on fTime)
	VS_output Output;

	float phasex = v.vXFloats.x * fTime + v.vXFloats.y;
	float posx = v.vXFloats.w + v.vXFloats.z * sin(phasex);

	float phasey = v.vYFloats.x * fTime + v.vYFloats.y;
	float posy = v.vYFloats.w + v.vYFloats.z * cos(phasey);
	
	Output.vPosition = float4(posx, posy, 0.0, 1.0);
	Output.vColor = float4(v.vXFloats.www * 0.5 + 0.5, v.vYFloats.w * 0.5 + 0.5);
//	Output.vColor = float4(1, 1, 1, 1);

	return Output;
}

technique DrawBlobs
{
	pass p0
	{
		AlphaBlendEnable = TRUE;
		DestBlend = INVSRCALPHA;
		SrcBlend = SRCALPHA;
		Texture[0] = NULL;
		VertexShader = compile vs_2_0 vs_draw_blobs();
		PixelShader = NULL;
	}
}
