#ifdef __cplusplus // C++
extern "C" {
#endif

#ifndef _MCHANNEL_H_INCLUDED
#define _MCHANNEL_H_INCLUDED

#include "bit.h"
#include "wavelet.h"

#pragma pack(push, 1)

typedef struct {
	t_wv_cchannel*	cc; // in
	float			max_mse; // in, interpreted as relative MSE when MaxBits is != 0
	// internal
	int		bits_alloced, bits_unused, old_bits;
} t_wv_mchannel_params;

#pragma pack(pop)

WAVELET_DLL_API int WAVELET_DLL_CC wv_rgb_to_ycbcr(const int Num, wv_pel* R, wv_pel* G, wv_pel* B);
WAVELET_DLL_API int WAVELET_DLL_CC wv_ycbcr_to_rgb(const int Num, wv_pel* Y, wv_pel* Cb, wv_pel* Cr);

WAVELET_DLL_API int WAVELET_DLL_CC wv_init_multi_channels(const int MaxBits, const float Threshold, const int NumChannels, t_wv_mchannel_params* Channels, t_wv_csettings** sets);

#endif // _MCHANNEL_H_INCLUDED

#ifdef __cplusplus // C++
}
#endif
